/*
 * segatex_editor SELinux tool.
 *
 * Copyright (C) 2007 Shintaro Fujiwara 
 * shintaro.fujiwara@gmai.com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * */

#include "parselines_selpaw.h"

//for debug
#include <iostream>
using namespace std;

//default constructor
ParseLinesSelpaw::ParseLinesSelpaw(){}
//constructor for Layout
ParseLinesSelpaw::ParseLinesSelpaw(QSplitter*&){}

void ParseLinesSelpaw::selpaw_admin()
{
	//change path as you wish.
	/////////////////////////////////////////////////////////////
	path_selpaw = "./";
	path_to_be_written_selpaw = "./selpaw_admin.txt";
	/////////////////////////////////////////////////////////////
	forward_slash = "/";
	cumma = ",";
	dir_selpaw.setPath(path);
	dir_name_selpaw = dir_selpaw.absPath();
	//cout << "dir_name_selpaw:" << dir_name_selpaw << endl;
	file_w_selpaw.setName(path_to_be_written_selpaw);
	/////////////////////////////////////////////////////////////
	dir_selpaw.setFilter( QDir::Files );
        dir_selpaw.setSorting( QDir::Name );
	//files = dir.entryList("*.if");
	files_selpaw = dir_selpaw.entryList("interfaces_admin_broken_up.txt");
	/////////////////////////////////////////////////////////////
	it_d_selpaw = files_selpaw.begin();
	if (file_w_selpaw.exists()) {
		file_w_selpaw.remove();
	}
	
	if ( file_w_selpaw.open( IO_WriteOnly | IO_Append ) ) {
		while(it_d_selpaw != files_selpaw.end()){
			name_selpaw = *it_d_selpaw;
			file_interface_name_selpaw = dir_name_selpaw + forward_slash + name_selpaw;
			//cout << "file_interface_name_selpaw:" << file_interface_name_selpaw << endl;
			QFile file_selpaw( file_interface_name_selpaw );
			if ( file_selpaw.open( IO_ReadOnly ) ) {
				//cout << "file_selpaw_opened" << endl;
			    QTextStream stream_selpaw( &file_selpaw );
				layer_name = "admin";
				////////////////////////////////////////////
				QRegExp rx_interface("^[a-zA-Z]");
				QRegExp rx_if_file_name("^:");
				QRegExp rx_colon(":");
				QRegExp rx_if(".if");
				////////////////////////////////////////////
				int i,j = -1;
				while ( !stream_selpaw.atEnd() ) {
					line_analized = stream_selpaw.readLine(); // line of text excluding '\n'
					//cout << "line_analized:" << line_analized << endl;
					i = line_analized.find( rx_interface, 0);
					j = line_analized.find( rx_if_file_name, 0);
					if(i != -1){
						interface_name_this = line_analized;//this adds to lines. also append can be used
					}
					if(j != -1){
						line_analized = line_analized.replace(":","");		
						line_analized = line_analized.replace(".if","");		
						filename_this = line_analized;//this adds to lines. also append can be used
					}
					if((i == -1)&&(j == -1)){
						line_analized = line_analized.stripWhiteSpace();
						lines_selpaw += layer_name + cumma + filename_this + cumma + interface_name_this + cumma + line_analized + cumma;
					}
				}
				QTextStream stream_w_selpaw( &file_w_selpaw );
				for ( it_selpaw = lines_selpaw.begin(); it_selpaw != lines_selpaw.end(); ++it_selpaw ){
					stream_w_selpaw << *it_selpaw << "\n";
				}
				file_selpaw.close();
				lines_selpaw.clear();
				++it_d_selpaw;
			}else{
				//do nothing
			}
		}
	}
	file_w_selpaw.close();
	selpaw_admin_types();
	selpaw_admin_types_which_policy_has();
	selpaw_admin_summary();
}//end-selpaw_admin

//should be called from selpaw_admin()
void ParseLinesSelpaw::selpaw_admin_types()
{
	//change path as you wish.
	/////////////////////////////////////////////////////////////
	path_selpaw = "./";
	path_to_be_written_selpaw = "./selpaw_admin_types.txt";
	/////////////////////////////////////////////////////////////
	forward_slash = "/";
	cumma = ",";
	dir_selpaw.setPath(path);
	dir_name_selpaw = dir_selpaw.absPath();
	//cout << "dir_name_selpaw:" << dir_name_selpaw << endl;
	file_w_selpaw.setName(path_to_be_written_selpaw);
	/////////////////////////////////////////////////////////////
	dir_selpaw.setFilter( QDir::Files );
        dir_selpaw.setSorting( QDir::Name );
	//files = dir.entryList("*.if");
	files_selpaw = dir_selpaw.entryList("interfaces_admin.txt");
	/////////////////////////////////////////////////////////////
	it_d_selpaw = files_selpaw.begin();
	if (file_w_selpaw.exists()) {
		file_w_selpaw.remove();
	}
	
	if ( file_w_selpaw.open( IO_WriteOnly | IO_Append ) ) {
		while(it_d_selpaw != files_selpaw.end()){
			name_selpaw = *it_d_selpaw;
			file_interface_name_selpaw = dir_name_selpaw + forward_slash + name_selpaw;
			//cout << "file_interface_name_selpaw:" << file_interface_name_selpaw << endl;
			QFile file_selpaw( file_interface_name_selpaw );
			if ( file_selpaw.open( IO_ReadOnly ) ) {
				//cout << "file_selpaw_opened" << endl;
			    QTextStream stream_selpaw( &file_selpaw );
				layer_name = "admin";
				////////////////////////////////////////////
				QRegExp rx_interface("^[a-zA-Z]");
				QRegExp rx_if_file_name("^:");
				QRegExp rx_colon(":");
				QRegExp rx_if(".if");
				QRegExp rx_gen_require("^\\[gen_require\\]");
				QRegExp rx_template("^template");
				////////////////////////////////////////////
				int i,j,k = -1;
				int temp_int = 0;
				while ( !stream_selpaw.atEnd() ) {
					line_analized = stream_selpaw.readLine(); // line of text excluding '\n'
					//cout << "line_analized:" << line_analized << endl;
					i = line_analized.find( rx_interface, 0);
					j = line_analized.find( rx_if_file_name, 0);
					k = line_analized.find( rx_gen_require, 0);
					if(i != -1){
						interface_name_this = line_analized;//this adds to lines. also append can be used
						temp_int = 0;
					}
					if( line_analized.find( rx_template, 0) != -1){
						temp_int = 1;
					}
					if(j != -1){
						line_analized = line_analized.replace(":","");		
						line_analized = line_analized.replace(".if","");		
						filename_this = line_analized;//this adds to lines. also append can be used
					}
					if((i == -1)&&(j == -1)&&(k != -1)&&(temp_int == 0)){
						line_analized = line_analized.stripWhiteSpace();
						lines_selpaw += layer_name + cumma + filename_this + cumma + interface_name_this + cumma + line_analized + cumma;
						
					}
				}
				QTextStream stream_w_selpaw( &file_w_selpaw );
				for ( it_selpaw = lines_selpaw.begin(); it_selpaw != lines_selpaw.end(); ++it_selpaw ){
					stream_w_selpaw << *it_selpaw << "\n";
				}
				file_selpaw.close();
				lines_selpaw.clear();
				++it_d_selpaw;
			}else{
				//do nothing
			}
		}
	}
	file_w_selpaw.close();
}//end-selpaw_admin_types

//should be called from selpaw_admin()
void ParseLinesSelpaw::selpaw_admin_summary()
{
	//change path as you wish.
	/////////////////////////////////////////////////////////////
	path_selpaw = "./";
	path_to_be_written_selpaw = "./selpaw_admin_summary.txt";
	/////////////////////////////////////////////////////////////
	forward_slash = "/";
	cumma = ",";
	dir_selpaw.setPath(path);
	dir_name_selpaw = dir_selpaw.absPath();
	//cout << "dir_name_selpaw:" << dir_name_selpaw << endl;
	file_w_selpaw.setName(path_to_be_written_selpaw);
	/////////////////////////////////////////////////////////////
	dir_selpaw.setFilter( QDir::Files );
        dir_selpaw.setSorting( QDir::Name );
	//files = dir.entryList("*.if");
	files_selpaw = dir_selpaw.entryList("interfaces_admin.txt");
	/////////////////////////////////////////////////////////////
	it_d_selpaw = files_selpaw.begin();
	if (file_w_selpaw.exists()) {
		file_w_selpaw.remove();
	}
	
	if ( file_w_selpaw.open( IO_WriteOnly | IO_Append ) ) {
		while(it_d_selpaw != files_selpaw.end()){
			name_selpaw = *it_d_selpaw;
			file_interface_name_selpaw = dir_name_selpaw + forward_slash + name_selpaw;
			//cout << "file_interface_name_selpaw:" << file_interface_name_selpaw << endl;
			QFile file_selpaw( file_interface_name_selpaw );
			if ( file_selpaw.open( IO_ReadOnly ) ) {
				//cout << "file_selpaw_opened" << endl;
			    QTextStream stream_selpaw( &file_selpaw );
				layer_name = "admin";
				////////////////////////////////////////////
				QRegExp rx_interface("^[a-zA-Z]");
				QRegExp rx_if_file_name("^:");
				QRegExp rx_colon(":");
				QRegExp rx_if(".if");
				QRegExp rx_gen_summary("^\\[summary\\]");
				QRegExp rx_template("^template");
				////////////////////////////////////////////
				int i,j,k = -1;
				while ( !stream_selpaw.atEnd() ) {
					line_analized = stream_selpaw.readLine(); // line of text excluding '\n'
					//cout << "line_analized:" << line_analized << endl;
					i = line_analized.find( rx_interface, 0);
					j = line_analized.find( rx_if_file_name, 0);
					k = line_analized.find( rx_gen_summary, 0);
					if( line_analized.find( rx_template, 0) != -1){
						interface_summary_this ="";
						line_analized ="";
						continue;
					}
					if(j != -1){
						line_analized = line_analized.replace(":","");		
						line_analized = line_analized.replace(".if","");		
						filename_this = line_analized;
					}
					if(k != -1){
						line_analized.replace("[summary]","");
						interface_summary_this += line_analized;
					}
					if((i != -1)&&(j == -1)&&(k == -1)){
						lines_selpaw += layer_name + cumma + filename_this + cumma + line_analized + cumma + "[summary]" + interface_summary_this + cumma;
						interface_summary_this = "";
					}
				}
				QTextStream stream_w_selpaw( &file_w_selpaw );
				for ( it_selpaw = lines_selpaw.begin(); it_selpaw != lines_selpaw.end(); ++it_selpaw ){
					stream_w_selpaw << *it_selpaw << "\n";
				}
				file_selpaw.close();
				lines_selpaw.clear();
				++it_d_selpaw;
			}else{
				//do nothing
			}
		}
	}
	file_w_selpaw.close();
}//end-selpaw_admin_summary

void ParseLinesSelpaw::selpaw_apps()
{
	//change path as you wish.
	/////////////////////////////////////////////////////////////
	path_selpaw = "./";
	path_to_be_written_selpaw = "./selpaw_apps.txt";
	/////////////////////////////////////////////////////////////
	forward_slash = "/";
	cumma = ",";
	dir_selpaw.setPath(path);
	dir_name_selpaw = dir_selpaw.absPath();
	//cout << "dir_name_selpaw:" << dir_name_selpaw << endl;
	file_w_selpaw.setName(path_to_be_written_selpaw);
	/////////////////////////////////////////////////////////////
	dir_selpaw.setFilter( QDir::Files );
        dir_selpaw.setSorting( QDir::Name );
	//files = dir.entryList("*.if");
	files_selpaw = dir_selpaw.entryList("interfaces_apps_broken_up.txt");
	/////////////////////////////////////////////////////////////
	it_d_selpaw = files_selpaw.begin();
	if (file_w_selpaw.exists()) {
		file_w_selpaw.remove();
	}
	
	if ( file_w_selpaw.open( IO_WriteOnly | IO_Append ) ) {
		while(it_d_selpaw != files_selpaw.end()){
			name_selpaw = *it_d_selpaw;
			file_interface_name_selpaw = dir_name_selpaw + forward_slash + name_selpaw;
			//cout << "file_interface_name_selpaw:" << file_interface_name_selpaw << endl;
			QFile file_selpaw( file_interface_name_selpaw );
			if ( file_selpaw.open( IO_ReadOnly ) ) {
				//cout << "file_selpaw_opened" << endl;
			    QTextStream stream_selpaw( &file_selpaw );
				layer_name = "apps";
				////////////////////////////////////////////
				QRegExp rx_interface("^[a-zA-Z]");
				QRegExp rx_if_file_name("^:");
				QRegExp rx_colon(":");
				QRegExp rx_if(".if");
				////////////////////////////////////////////
				int i,j = -1;
				while ( !stream_selpaw.atEnd() ) {
					line_analized = stream_selpaw.readLine(); // line of text excluding '\n'
					//cout << "line_analized:" << line_analized << endl;
					i = line_analized.find( rx_interface, 0);
					j = line_analized.find( rx_if_file_name, 0);
					if(i != -1){
						interface_name_this = line_analized;//this adds to lines. also append can be used
					}
					if(j != -1){
						line_analized = line_analized.replace(":","");		
						line_analized = line_analized.replace(".if","");		
						filename_this = line_analized;//this adds to lines. also append can be used
					}
					if((i == -1)&&(j == -1)){
						line_analized = line_analized.stripWhiteSpace();
						lines_selpaw += layer_name + cumma + filename_this + cumma + interface_name_this + cumma + line_analized + cumma;
					}
				}
				QTextStream stream_w_selpaw( &file_w_selpaw );
				for ( it_selpaw = lines_selpaw.begin(); it_selpaw != lines_selpaw.end(); ++it_selpaw ){
					stream_w_selpaw << *it_selpaw << "\n";
				}
				file_selpaw.close();
				lines_selpaw.clear();
				++it_d_selpaw;
			}else{
				//do nothing
			}
		}
	}
	file_w_selpaw.close();
	selpaw_apps_types();
	selpaw_apps_summary();
}//end-selpaw_apps

//should be called from selpaw_apps()
void ParseLinesSelpaw::selpaw_apps_types()
{
	//change path as you wish.
	/////////////////////////////////////////////////////////////
	path_selpaw = "./";
	path_to_be_written_selpaw = "./selpaw_apps_types.txt";
	/////////////////////////////////////////////////////////////
	forward_slash = "/";
	cumma = ",";
	dir_selpaw.setPath(path);
	dir_name_selpaw = dir_selpaw.absPath();
	//cout << "dir_name_selpaw:" << dir_name_selpaw << endl;
	file_w_selpaw.setName(path_to_be_written_selpaw);
	/////////////////////////////////////////////////////////////
	dir_selpaw.setFilter( QDir::Files );
        dir_selpaw.setSorting( QDir::Name );
	//files = dir.entryList("*.if");
	files_selpaw = dir_selpaw.entryList("interfaces_apps.txt");
	/////////////////////////////////////////////////////////////
	it_d_selpaw = files_selpaw.begin();
	if (file_w_selpaw.exists()) {
		file_w_selpaw.remove();
	}
	
	if ( file_w_selpaw.open( IO_WriteOnly | IO_Append ) ) {
		while(it_d_selpaw != files_selpaw.end()){
			name_selpaw = *it_d_selpaw;
			file_interface_name_selpaw = dir_name_selpaw + forward_slash + name_selpaw;
			//cout << "file_interface_name_selpaw:" << file_interface_name_selpaw << endl;
			QFile file_selpaw( file_interface_name_selpaw );
			if ( file_selpaw.open( IO_ReadOnly ) ) {
				//cout << "file_selpaw_opened" << endl;
			    QTextStream stream_selpaw( &file_selpaw );
				layer_name = "apps";
				////////////////////////////////////////////
				QRegExp rx_interface("^[a-zA-Z]");
				QRegExp rx_if_file_name("^:");
				QRegExp rx_colon(":");
				QRegExp rx_if(".if");
				QRegExp rx_gen_require("^\\[gen_require\\]");
				QRegExp rx_template("^template");
				////////////////////////////////////////////
				int i,j,k = -1;
				int temp_int = 0;
				while ( !stream_selpaw.atEnd() ) {
					line_analized = stream_selpaw.readLine(); // line of text excluding '\n'
					//cout << "line_analized:" << line_analized << endl;
					i = line_analized.find( rx_interface, 0);
					j = line_analized.find( rx_if_file_name, 0);
					k = line_analized.find( rx_gen_require, 0);
					if(i != -1){
						interface_name_this = line_analized;//this adds to lines. also append can be used
						temp_int = 0;
					}
					if( line_analized.find( rx_template, 0) != -1){
						temp_int = 1;
					}
					if(j != -1){
						line_analized = line_analized.replace(":","");		
						line_analized = line_analized.replace(".if","");		
						filename_this = line_analized;//this adds to lines. also append can be used
					}
					if((i == -1)&&(j == -1)&&(k != -1)&&(temp_int == 0)){
						line_analized = line_analized.stripWhiteSpace();
						lines_selpaw += layer_name + cumma + filename_this + cumma + interface_name_this + cumma + line_analized + cumma;
						
					}
				}
				QTextStream stream_w_selpaw( &file_w_selpaw );
				for ( it_selpaw = lines_selpaw.begin(); it_selpaw != lines_selpaw.end(); ++it_selpaw ){
					stream_w_selpaw << *it_selpaw << "\n";
				}
				file_selpaw.close();
				lines_selpaw.clear();
				++it_d_selpaw;
			}else{
				//do nothing
			}
		}
	}
	file_w_selpaw.close();
}//end-selpaw_apps_types

//should be called from selpaw_apps()
void ParseLinesSelpaw::selpaw_apps_summary()
{
	//change path as you wish.
	/////////////////////////////////////////////////////////////
	path_selpaw = "./";
	path_to_be_written_selpaw = "./selpaw_apps_summary.txt";
	/////////////////////////////////////////////////////////////
	forward_slash = "/";
	cumma = ",";
	dir_selpaw.setPath(path);
	dir_name_selpaw = dir_selpaw.absPath();
	//cout << "dir_name_selpaw:" << dir_name_selpaw << endl;
	file_w_selpaw.setName(path_to_be_written_selpaw);
	/////////////////////////////////////////////////////////////
	dir_selpaw.setFilter( QDir::Files );
        dir_selpaw.setSorting( QDir::Name );
	//files = dir.entryList("*.if");
	files_selpaw = dir_selpaw.entryList("interfaces_apps.txt");
	/////////////////////////////////////////////////////////////
	it_d_selpaw = files_selpaw.begin();
	if (file_w_selpaw.exists()) {
		file_w_selpaw.remove();
	}
	
	if ( file_w_selpaw.open( IO_WriteOnly | IO_Append ) ) {
		while(it_d_selpaw != files_selpaw.end()){
			name_selpaw = *it_d_selpaw;
			file_interface_name_selpaw = dir_name_selpaw + forward_slash + name_selpaw;
			//cout << "file_interface_name_selpaw:" << file_interface_name_selpaw << endl;
			QFile file_selpaw( file_interface_name_selpaw );
			if ( file_selpaw.open( IO_ReadOnly ) ) {
				//cout << "file_selpaw_opened" << endl;
			    QTextStream stream_selpaw( &file_selpaw );
				layer_name = "apps";
				////////////////////////////////////////////
				QRegExp rx_interface("^[a-zA-Z]");
				QRegExp rx_if_file_name("^:");
				QRegExp rx_colon(":");
				QRegExp rx_if(".if");
				QRegExp rx_gen_summary("^\\[summary\\]");
				QRegExp rx_template("^template");
				////////////////////////////////////////////
				int i,j,k = -1;
				while ( !stream_selpaw.atEnd() ) {
					line_analized = stream_selpaw.readLine(); // line of text excluding '\n'
					//cout << "line_analized:" << line_analized << endl;
					i = line_analized.find( rx_interface, 0);
					j = line_analized.find( rx_if_file_name, 0);
					k = line_analized.find( rx_gen_summary, 0);
					if( line_analized.find( rx_template, 0) != -1){
						interface_summary_this ="";
						line_analized ="";
						continue;
					}
					if(j != -1){
						line_analized = line_analized.replace(":","");		
						line_analized = line_analized.replace(".if","");		
						filename_this = line_analized;
					}
					if(k != -1){
						line_analized.replace("[summary]","");
						interface_summary_this += line_analized;
					}
					if((i != -1)&&(j == -1)&&(k == -1)){
						lines_selpaw += layer_name + cumma + filename_this + cumma + line_analized + cumma + "[summary]" + interface_summary_this + cumma;
						interface_summary_this = "";
					}
				}
				QTextStream stream_w_selpaw( &file_w_selpaw );
				for ( it_selpaw = lines_selpaw.begin(); it_selpaw != lines_selpaw.end(); ++it_selpaw ){
					stream_w_selpaw << *it_selpaw << "\n";
				}
				file_selpaw.close();
				lines_selpaw.clear();
				++it_d_selpaw;
			}else{
				//do nothing
			}
		}
	}
	file_w_selpaw.close();
}//end-selpaw_apps_summary

void ParseLinesSelpaw::selpaw_kernel()
{
	//change path as you wish.
	/////////////////////////////////////////////////////////////
	path_selpaw = "./";
	path_to_be_written_selpaw = "./selpaw_kernel.txt";
	/////////////////////////////////////////////////////////////
	forward_slash = "/";
	cumma = ",";
	dir_selpaw.setPath(path);
	dir_name_selpaw = dir_selpaw.absPath();
	//cout << "dir_name_selpaw:" << dir_name_selpaw << endl;
	file_w_selpaw.setName(path_to_be_written_selpaw);
	/////////////////////////////////////////////////////////////
	dir_selpaw.setFilter( QDir::Files );
        dir_selpaw.setSorting( QDir::Name );
	//files = dir.entryList("*.if");
	files_selpaw = dir_selpaw.entryList("interfaces_kernel_broken_up.txt");
	/////////////////////////////////////////////////////////////
	it_d_selpaw = files_selpaw.begin();
	if (file_w_selpaw.exists()) {
		file_w_selpaw.remove();
	}
	
	if ( file_w_selpaw.open( IO_WriteOnly | IO_Append ) ) {
		while(it_d_selpaw != files_selpaw.end()){
			name_selpaw = *it_d_selpaw;
			file_interface_name_selpaw = dir_name_selpaw + forward_slash + name_selpaw;
			//cout << "file_interface_name_selpaw:" << file_interface_name_selpaw << endl;
			QFile file_selpaw( file_interface_name_selpaw );
			if ( file_selpaw.open( IO_ReadOnly ) ) {
				//cout << "file_selpaw_opened" << endl;
			    QTextStream stream_selpaw( &file_selpaw );
				layer_name = "kernel";
				////////////////////////////////////////////
				QRegExp rx_interface("^[a-zA-Z]");
				QRegExp rx_if_file_name("^:");
				QRegExp rx_colon(":");
				QRegExp rx_if(".if");
				////////////////////////////////////////////
				int i,j = -1;
				while ( !stream_selpaw.atEnd() ) {
					line_analized = stream_selpaw.readLine(); // line of text excluding '\n'
					//cout << "line_analized:" << line_analized << endl;
					i = line_analized.find( rx_interface, 0);
					j = line_analized.find( rx_if_file_name, 0);
					if(i != -1){
						interface_name_this = line_analized;//this adds to lines. also append can be used
					}
					if(j != -1){
						line_analized = line_analized.replace(":","");		
						line_analized = line_analized.replace(".if","");		
						filename_this = line_analized;//this adds to lines. also append can be used
					}
					if((i == -1)&&(j == -1)){
						line_analized = line_analized.stripWhiteSpace();
						lines_selpaw += layer_name + cumma + filename_this + cumma + interface_name_this + cumma + line_analized + cumma;
					}
				}
				QTextStream stream_w_selpaw( &file_w_selpaw );
				for ( it_selpaw = lines_selpaw.begin(); it_selpaw != lines_selpaw.end(); ++it_selpaw ){
					stream_w_selpaw << *it_selpaw << "\n";
				}
				file_selpaw.close();
				lines_selpaw.clear();
				++it_d_selpaw;
			}else{
				//do nothing
			}
		}
	}
	file_w_selpaw.close();
	selpaw_kernel_types();
	selpaw_kernel_summary();
}//end-selpaw_kernel

//should be called from selpaw_kernel()
void ParseLinesSelpaw::selpaw_kernel_types()
{
	//change path as you wish.
	/////////////////////////////////////////////////////////////
	path_selpaw = "./";
	path_to_be_written_selpaw = "./selpaw_kernel_types.txt";
	/////////////////////////////////////////////////////////////
	forward_slash = "/";
	cumma = ",";
	dir_selpaw.setPath(path);
	dir_name_selpaw = dir_selpaw.absPath();
	//cout << "dir_name_selpaw:" << dir_name_selpaw << endl;
	file_w_selpaw.setName(path_to_be_written_selpaw);
	/////////////////////////////////////////////////////////////
	dir_selpaw.setFilter( QDir::Files );
        dir_selpaw.setSorting( QDir::Name );
	//files = dir.entryList("*.if");
	files_selpaw = dir_selpaw.entryList("interfaces_kernel.txt");
	/////////////////////////////////////////////////////////////
	it_d_selpaw = files_selpaw.begin();
	if (file_w_selpaw.exists()) {
		file_w_selpaw.remove();
	}
	
	if ( file_w_selpaw.open( IO_WriteOnly | IO_Append ) ) {
		while(it_d_selpaw != files_selpaw.end()){
			name_selpaw = *it_d_selpaw;
			file_interface_name_selpaw = dir_name_selpaw + forward_slash + name_selpaw;
			//cout << "file_interface_name_selpaw:" << file_interface_name_selpaw << endl;
			QFile file_selpaw( file_interface_name_selpaw );
			if ( file_selpaw.open( IO_ReadOnly ) ) {
				//cout << "file_selpaw_opened" << endl;
			    QTextStream stream_selpaw( &file_selpaw );
				layer_name = "kernel";
				////////////////////////////////////////////
				QRegExp rx_interface("^[a-zA-Z]");
				QRegExp rx_if_file_name("^:");
				QRegExp rx_colon(":");
				QRegExp rx_if(".if");
				QRegExp rx_gen_require("^\\[gen_require\\]");
				QRegExp rx_template("^template");
				////////////////////////////////////////////
				int i,j,k = -1;
				int temp_int = 0;
				while ( !stream_selpaw.atEnd() ) {
					line_analized = stream_selpaw.readLine(); // line of text excluding '\n'
					//cout << "line_analized:" << line_analized << endl;
					i = line_analized.find( rx_interface, 0);
					j = line_analized.find( rx_if_file_name, 0);
					k = line_analized.find( rx_gen_require, 0);
					if(i != -1){
						interface_name_this = line_analized;//this adds to lines. also append can be used
						temp_int = 0;
					}
					if( line_analized.find( rx_template, 0) != -1){
						temp_int = 1;
					}
					if(j != -1){
						line_analized = line_analized.replace(":","");		
						line_analized = line_analized.replace(".if","");		
						filename_this = line_analized;//this adds to lines. also append can be used
					}
					if((i == -1)&&(j == -1)&&(k != -1)&&(temp_int == 0)){
						line_analized = line_analized.stripWhiteSpace();
						lines_selpaw += layer_name + cumma + filename_this + cumma + interface_name_this + cumma + line_analized + cumma;
						
					}
				}
				QTextStream stream_w_selpaw( &file_w_selpaw );
				for ( it_selpaw = lines_selpaw.begin(); it_selpaw != lines_selpaw.end(); ++it_selpaw ){
					stream_w_selpaw << *it_selpaw << "\n";
				}
				file_selpaw.close();
				lines_selpaw.clear();
				++it_d_selpaw;
			}else{
				//do nothing
			}
		}
	}
	file_w_selpaw.close();
}//end-selpaw_kernel_types

//should be called from selpaw_kernel()
void ParseLinesSelpaw::selpaw_kernel_summary()
{
	//change path as you wish.
	/////////////////////////////////////////////////////////////
	path_selpaw = "./";
	path_to_be_written_selpaw = "./selpaw_kernel_summary.txt";
	/////////////////////////////////////////////////////////////
	forward_slash = "/";
	cumma = ",";
	dir_selpaw.setPath(path);
	dir_name_selpaw = dir_selpaw.absPath();
	//cout << "dir_name_selpaw:" << dir_name_selpaw << endl;
	file_w_selpaw.setName(path_to_be_written_selpaw);
	/////////////////////////////////////////////////////////////
	dir_selpaw.setFilter( QDir::Files );
        dir_selpaw.setSorting( QDir::Name );
	//files = dir.entryList("*.if");
	files_selpaw = dir_selpaw.entryList("interfaces_kernel.txt");
	/////////////////////////////////////////////////////////////
	it_d_selpaw = files_selpaw.begin();
	if (file_w_selpaw.exists()) {
		file_w_selpaw.remove();
	}
	
	if ( file_w_selpaw.open( IO_WriteOnly | IO_Append ) ) {
		while(it_d_selpaw != files_selpaw.end()){
			name_selpaw = *it_d_selpaw;
			file_interface_name_selpaw = dir_name_selpaw + forward_slash + name_selpaw;
			//cout << "file_interface_name_selpaw:" << file_interface_name_selpaw << endl;
			QFile file_selpaw( file_interface_name_selpaw );
			if ( file_selpaw.open( IO_ReadOnly ) ) {
				//cout << "file_selpaw_opened" << endl;
			    QTextStream stream_selpaw( &file_selpaw );
				layer_name = "kernel";
				////////////////////////////////////////////
				QRegExp rx_interface("^[a-zA-Z]");
				QRegExp rx_if_file_name("^:");
				QRegExp rx_colon(":");
				QRegExp rx_if(".if");
				QRegExp rx_gen_summary("^\\[summary\\]");
				QRegExp rx_template("^template");
				////////////////////////////////////////////
				int i,j,k = -1;
				while ( !stream_selpaw.atEnd() ) {
					line_analized = stream_selpaw.readLine(); // line of text excluding '\n'
					//cout << "line_analized:" << line_analized << endl;
					i = line_analized.find( rx_interface, 0);
					j = line_analized.find( rx_if_file_name, 0);
					k = line_analized.find( rx_gen_summary, 0);
					if( line_analized.find( rx_template, 0) != -1){
						interface_summary_this ="";
						line_analized ="";
						continue;
					}
					if(j != -1){
						line_analized = line_analized.replace(":","");		
						line_analized = line_analized.replace(".if","");		
						filename_this = line_analized;
					}
					if(k != -1){
						line_analized.replace("[summary]","");
						interface_summary_this += line_analized;
					}
					if((i != -1)&&(j == -1)&&(k == -1)){
						lines_selpaw += layer_name + cumma + filename_this + cumma + line_analized + cumma + "[summary]" + interface_summary_this + cumma;
						interface_summary_this = "";
					}
				}
				QTextStream stream_w_selpaw( &file_w_selpaw );
				for ( it_selpaw = lines_selpaw.begin(); it_selpaw != lines_selpaw.end(); ++it_selpaw ){
					stream_w_selpaw << *it_selpaw << "\n";
				}
				file_selpaw.close();
				lines_selpaw.clear();
				++it_d_selpaw;
			}else{
				//do nothing
			}
		}
	}
	file_w_selpaw.close();
}//end-selpaw_kernel_summary

void ParseLinesSelpaw::selpaw_services()
{
	//change path as you wish.
	/////////////////////////////////////////////////////////////
	path_selpaw = "./";
	path_to_be_written_selpaw = "./selpaw_services.txt";
	/////////////////////////////////////////////////////////////
	forward_slash = "/";
	cumma = ",";
	dir_selpaw.setPath(path);
	dir_name_selpaw = dir_selpaw.absPath();
	//cout << "dir_name_selpaw:" << dir_name_selpaw << endl;
	file_w_selpaw.setName(path_to_be_written_selpaw);
	/////////////////////////////////////////////////////////////
	dir_selpaw.setFilter( QDir::Files );
        dir_selpaw.setSorting( QDir::Name );
	//files = dir.entryList("*.if");
	files_selpaw = dir_selpaw.entryList("interfaces_services_broken_up.txt");
	/////////////////////////////////////////////////////////////
	it_d_selpaw = files_selpaw.begin();
	if (file_w_selpaw.exists()) {
		file_w_selpaw.remove();
	}
	
	if ( file_w_selpaw.open( IO_WriteOnly | IO_Append ) ) {
		while(it_d_selpaw != files_selpaw.end()){
			name_selpaw = *it_d_selpaw;
			file_interface_name_selpaw = dir_name_selpaw + forward_slash + name_selpaw;
			//cout << "file_interface_name_selpaw:" << file_interface_name_selpaw << endl;
			QFile file_selpaw( file_interface_name_selpaw );
			if ( file_selpaw.open( IO_ReadOnly ) ) {
				//cout << "file_selpaw_opened" << endl;
			    QTextStream stream_selpaw( &file_selpaw );
				layer_name = "services";
				////////////////////////////////////////////
				QRegExp rx_interface("^[a-zA-Z]");
				QRegExp rx_if_file_name("^:");
				QRegExp rx_colon(":");
				QRegExp rx_if(".if");
				////////////////////////////////////////////
				int i,j = -1;
				while ( !stream_selpaw.atEnd() ) {
					line_analized = stream_selpaw.readLine(); // line of text excluding '\n'
					//cout << "line_analized:" << line_analized << endl;
					i = line_analized.find( rx_interface, 0);
					j = line_analized.find( rx_if_file_name, 0);
					if(i != -1){
						interface_name_this = line_analized;//this adds to lines. also append can be used
					}
					if(j != -1){
						line_analized = line_analized.replace(":","");		
						line_analized = line_analized.replace(".if","");		
						filename_this = line_analized;//this adds to lines. also append can be used
					}
					if((i == -1)&&(j == -1)){
						line_analized = line_analized.stripWhiteSpace();
						lines_selpaw += layer_name + cumma + filename_this + cumma + interface_name_this + cumma + line_analized + cumma;
					}
				}
				QTextStream stream_w_selpaw( &file_w_selpaw );
				for ( it_selpaw = lines_selpaw.begin(); it_selpaw != lines_selpaw.end(); ++it_selpaw ){
					stream_w_selpaw << *it_selpaw << "\n";
				}
				file_selpaw.close();
				lines_selpaw.clear();
				++it_d_selpaw;
			}else{
				//do nothing
			}
		}
	}
	file_w_selpaw.close();
	selpaw_services_types();
	selpaw_services_summary();
}//end-selpaw_services

//should be called from selpaw_services()
void ParseLinesSelpaw::selpaw_services_types()
{
	//change path as you wish.
	/////////////////////////////////////////////////////////////
	path_selpaw = "./";
	path_to_be_written_selpaw = "./selpaw_services_types.txt";
	/////////////////////////////////////////////////////////////
	forward_slash = "/";
	cumma = ",";
	dir_selpaw.setPath(path);
	dir_name_selpaw = dir_selpaw.absPath();
	//cout << "dir_name_selpaw:" << dir_name_selpaw << endl;
	file_w_selpaw.setName(path_to_be_written_selpaw);
	/////////////////////////////////////////////////////////////
	dir_selpaw.setFilter( QDir::Files );
        dir_selpaw.setSorting( QDir::Name );
	//files = dir.entryList("*.if");
	files_selpaw = dir_selpaw.entryList("interfaces_services.txt");
	/////////////////////////////////////////////////////////////
	it_d_selpaw = files_selpaw.begin();
	if (file_w_selpaw.exists()) {
		file_w_selpaw.remove();
	}
	
	if ( file_w_selpaw.open( IO_WriteOnly | IO_Append ) ) {
		while(it_d_selpaw != files_selpaw.end()){
			name_selpaw = *it_d_selpaw;
			file_interface_name_selpaw = dir_name_selpaw + forward_slash + name_selpaw;
			//cout << "file_interface_name_selpaw:" << file_interface_name_selpaw << endl;
			QFile file_selpaw( file_interface_name_selpaw );
			if ( file_selpaw.open( IO_ReadOnly ) ) {
				//cout << "file_selpaw_opened" << endl;
			    QTextStream stream_selpaw( &file_selpaw );
				layer_name = "services";
				////////////////////////////////////////////
				QRegExp rx_interface("^[a-zA-Z]");
				QRegExp rx_if_file_name("^:");
				QRegExp rx_colon(":");
				QRegExp rx_if(".if");
				QRegExp rx_gen_require("^\\[gen_require\\]");
				QRegExp rx_template("^template");
				////////////////////////////////////////////
				int i,j,k = -1;
				int temp_int = 0;
				while ( !stream_selpaw.atEnd() ) {
					line_analized = stream_selpaw.readLine(); // line of text excluding '\n'
					//cout << "line_analized:" << line_analized << endl;
					i = line_analized.find( rx_interface, 0);
					j = line_analized.find( rx_if_file_name, 0);
					k = line_analized.find( rx_gen_require, 0);
					if(i != -1){
						interface_name_this = line_analized;//this adds to lines. also append can be used
						temp_int = 0;
					}
					if( line_analized.find( rx_template, 0) != -1){
						temp_int = 1;
					}
					if(j != -1){
						line_analized = line_analized.replace(":","");		
						line_analized = line_analized.replace(".if","");		
						filename_this = line_analized;//this adds to lines. also append can be used
					}
					if((i == -1)&&(j == -1)&&(k != -1)&&(temp_int == 0)){
						line_analized = line_analized.stripWhiteSpace();
						lines_selpaw += layer_name + cumma + filename_this + cumma + interface_name_this + cumma + line_analized + cumma;
						
					}
				}
				QTextStream stream_w_selpaw( &file_w_selpaw );
				for ( it_selpaw = lines_selpaw.begin(); it_selpaw != lines_selpaw.end(); ++it_selpaw ){
					stream_w_selpaw << *it_selpaw << "\n";
				}
				file_selpaw.close();
				lines_selpaw.clear();
				++it_d_selpaw;
			}else{
				//do nothing
			}
		}
	}
	file_w_selpaw.close();
}//end-selpaw_services_types

//should be called from selpaw_services()
void ParseLinesSelpaw::selpaw_services_summary()
{
	//change path as you wish.
	/////////////////////////////////////////////////////////////
	path_selpaw = "./";
	path_to_be_written_selpaw = "./selpaw_services_summary.txt";
	/////////////////////////////////////////////////////////////
	forward_slash = "/";
	cumma = ",";
	dir_selpaw.setPath(path);
	dir_name_selpaw = dir_selpaw.absPath();
	//cout << "dir_name_selpaw:" << dir_name_selpaw << endl;
	file_w_selpaw.setName(path_to_be_written_selpaw);
	/////////////////////////////////////////////////////////////
	dir_selpaw.setFilter( QDir::Files );
        dir_selpaw.setSorting( QDir::Name );
	//files = dir.entryList("*.if");
	files_selpaw = dir_selpaw.entryList("interfaces_services.txt");
	/////////////////////////////////////////////////////////////
	it_d_selpaw = files_selpaw.begin();
	if (file_w_selpaw.exists()) {
		file_w_selpaw.remove();
	}
	
	if ( file_w_selpaw.open( IO_WriteOnly | IO_Append ) ) {
		while(it_d_selpaw != files_selpaw.end()){
			name_selpaw = *it_d_selpaw;
			file_interface_name_selpaw = dir_name_selpaw + forward_slash + name_selpaw;
			//cout << "file_interface_name_selpaw:" << file_interface_name_selpaw << endl;
			QFile file_selpaw( file_interface_name_selpaw );
			if ( file_selpaw.open( IO_ReadOnly ) ) {
				//cout << "file_selpaw_opened" << endl;
			    QTextStream stream_selpaw( &file_selpaw );
				layer_name = "services";
				////////////////////////////////////////////
				QRegExp rx_interface("^[a-zA-Z]");
				QRegExp rx_if_file_name("^:");
				QRegExp rx_colon(":");
				QRegExp rx_if(".if");
				QRegExp rx_gen_summary("^\\[summary\\]");
				QRegExp rx_template("^template");
				////////////////////////////////////////////
				int i,j,k = -1;
				while ( !stream_selpaw.atEnd() ) {
					line_analized = stream_selpaw.readLine(); // line of text excluding '\n'
					//cout << "line_analized:" << line_analized << endl;
					i = line_analized.find( rx_interface, 0);
					j = line_analized.find( rx_if_file_name, 0);
					k = line_analized.find( rx_gen_summary, 0);
					if( line_analized.find( rx_template, 0) != -1){
						interface_summary_this ="";
						line_analized ="";
						continue;
					}
					if(j != -1){
						line_analized = line_analized.replace(":","");		
						line_analized = line_analized.replace(".if","");		
						filename_this = line_analized;
					}
					if(k != -1){
						line_analized.replace("[summary]","");
						interface_summary_this += line_analized;
					}
					if((i != -1)&&(j == -1)&&(k == -1)){
						lines_selpaw += layer_name + cumma + filename_this + cumma + line_analized + cumma + "[summary]" + interface_summary_this + cumma;
						interface_summary_this = "";
					}
				}
				QTextStream stream_w_selpaw( &file_w_selpaw );
				for ( it_selpaw = lines_selpaw.begin(); it_selpaw != lines_selpaw.end(); ++it_selpaw ){
					stream_w_selpaw << *it_selpaw << "\n";
				}
				file_selpaw.close();
				lines_selpaw.clear();
				++it_d_selpaw;
			}else{
				//do nothing
			}
		}
	}
	file_w_selpaw.close();
}//end-selpaw_services_summary

void ParseLinesSelpaw::selpaw_system()
{
	//change path as you wish.
	/////////////////////////////////////////////////////////////
	path_selpaw = "./";
	path_to_be_written_selpaw = "./selpaw_system.txt";
	/////////////////////////////////////////////////////////////
	forward_slash = "/";
	cumma = ",";
	dir_selpaw.setPath(path);
	dir_name_selpaw = dir_selpaw.absPath();
	//cout << "dir_name_selpaw:" << dir_name_selpaw << endl;
	file_w_selpaw.setName(path_to_be_written_selpaw);
	/////////////////////////////////////////////////////////////
	dir_selpaw.setFilter( QDir::Files );
        dir_selpaw.setSorting( QDir::Name );
	//files = dir.entryList("*.if");
	files_selpaw = dir_selpaw.entryList("interfaces_system_broken_up.txt");
	/////////////////////////////////////////////////////////////
	it_d_selpaw = files_selpaw.begin();
	if (file_w_selpaw.exists()) {
		file_w_selpaw.remove();
	}
	
	if ( file_w_selpaw.open( IO_WriteOnly | IO_Append ) ) {
		while(it_d_selpaw != files_selpaw.end()){
			name_selpaw = *it_d_selpaw;
			file_interface_name_selpaw = dir_name_selpaw + forward_slash + name_selpaw;
			//cout << "file_interface_name_selpaw:" << file_interface_name_selpaw << endl;
			QFile file_selpaw( file_interface_name_selpaw );
			if ( file_selpaw.open( IO_ReadOnly ) ) {
				//cout << "file_selpaw_opened" << endl;
			    QTextStream stream_selpaw( &file_selpaw );
				layer_name = "system";
				////////////////////////////////////////////
				QRegExp rx_interface("^[a-zA-Z]");
				QRegExp rx_if_file_name("^:");
				QRegExp rx_colon(":");
				QRegExp rx_if(".if");
				////////////////////////////////////////////
				int i,j = -1;
				while ( !stream_selpaw.atEnd() ) {
					line_analized = stream_selpaw.readLine(); // line of text excluding '\n'
					//cout << "line_analized:" << line_analized << endl;
					i = line_analized.find( rx_interface, 0);
					j = line_analized.find( rx_if_file_name, 0);
					if(i != -1){
						interface_name_this = line_analized;//this adds to lines. also append can be used
					}
					if(j != -1){
						line_analized = line_analized.replace(":","");		
						line_analized = line_analized.replace(".if","");		
						filename_this = line_analized;//this adds to lines. also append can be used
					}
					if((i == -1)&&(j == -1)){
						line_analized = line_analized.stripWhiteSpace();
						lines_selpaw += layer_name + cumma + filename_this + cumma + interface_name_this + cumma + line_analized + cumma;
					}
				}
				QTextStream stream_w_selpaw( &file_w_selpaw );
				for ( it_selpaw = lines_selpaw.begin(); it_selpaw != lines_selpaw.end(); ++it_selpaw ){
					stream_w_selpaw << *it_selpaw << "\n";
				}
				file_selpaw.close();
				lines_selpaw.clear();
				++it_d_selpaw;
			}else{
				//do nothing
			}
		}
	}
	file_w_selpaw.close();
	selpaw_system_types();
	selpaw_system_summary();
}//end-selpaw_system

//should be called from selpaw_system()
void ParseLinesSelpaw::selpaw_system_types()
{
	//change path as you wish.
	/////////////////////////////////////////////////////////////
	path_selpaw = "./";
	path_to_be_written_selpaw = "./selpaw_system_types.txt";
	/////////////////////////////////////////////////////////////
	forward_slash = "/";
	cumma = ",";
	dir_selpaw.setPath(path);
	dir_name_selpaw = dir_selpaw.absPath();
	//cout << "dir_name_selpaw:" << dir_name_selpaw << endl;
	file_w_selpaw.setName(path_to_be_written_selpaw);
	/////////////////////////////////////////////////////////////
	dir_selpaw.setFilter( QDir::Files );
        dir_selpaw.setSorting( QDir::Name );
	//files = dir.entryList("*.if");
	files_selpaw = dir_selpaw.entryList("interfaces_system.txt");
	/////////////////////////////////////////////////////////////
	it_d_selpaw = files_selpaw.begin();
	if (file_w_selpaw.exists()) {
		file_w_selpaw.remove();
	}
	
	if ( file_w_selpaw.open( IO_WriteOnly | IO_Append ) ) {
		while(it_d_selpaw != files_selpaw.end()){
			name_selpaw = *it_d_selpaw;
			file_interface_name_selpaw = dir_name_selpaw + forward_slash + name_selpaw;
			//cout << "file_interface_name_selpaw:" << file_interface_name_selpaw << endl;
			QFile file_selpaw( file_interface_name_selpaw );
			if ( file_selpaw.open( IO_ReadOnly ) ) {
				//cout << "file_selpaw_opened" << endl;
			    QTextStream stream_selpaw( &file_selpaw );
				layer_name = "system";
				////////////////////////////////////////////
				QRegExp rx_interface("^[a-zA-Z]");
				QRegExp rx_if_file_name("^:");
				QRegExp rx_colon(":");
				QRegExp rx_if(".if");
				QRegExp rx_gen_require("^\\[gen_require\\]");
				QRegExp rx_template("^template");
				////////////////////////////////////////////
				int i,j,k = -1;
				int temp_int = 0;
				while ( !stream_selpaw.atEnd() ) {
					line_analized = stream_selpaw.readLine(); // line of text excluding '\n'
					//cout << "line_analized:" << line_analized << endl;
					i = line_analized.find( rx_interface, 0);
					j = line_analized.find( rx_if_file_name, 0);
					k = line_analized.find( rx_gen_require, 0);
					if(i != -1){
						interface_name_this = line_analized;//this adds to lines. also append can be used
						temp_int = 0;
					}
					if( line_analized.find( rx_template, 0) != -1){
						temp_int = 1;
					}
					if(j != -1){
						line_analized = line_analized.replace(":","");		
						line_analized = line_analized.replace(".if","");		
						filename_this = line_analized;//this adds to lines. also append can be used
					}
					if((i == -1)&&(j == -1)&&(k != -1)&&(temp_int == 0)){
						line_analized = line_analized.stripWhiteSpace();
						lines_selpaw += layer_name + cumma + filename_this + cumma + interface_name_this + cumma + line_analized + cumma;
						
					}
				}
				QTextStream stream_w_selpaw( &file_w_selpaw );
				for ( it_selpaw = lines_selpaw.begin(); it_selpaw != lines_selpaw.end(); ++it_selpaw ){
					stream_w_selpaw << *it_selpaw << "\n";
				}
				file_selpaw.close();
				lines_selpaw.clear();
				++it_d_selpaw;
			}else{
				//do nothing
			}
		}
	}
	file_w_selpaw.close();
}//end-selpaw_system_types

//should be called from selpaw_system()
void ParseLinesSelpaw::selpaw_system_summary()
{
	//change path as you wish.
	/////////////////////////////////////////////////////////////
	path_selpaw = "./";
	path_to_be_written_selpaw = "./selpaw_system_summary.txt";
	/////////////////////////////////////////////////////////////
	forward_slash = "/";
	cumma = ",";
	dir_selpaw.setPath(path);
	dir_name_selpaw = dir_selpaw.absPath();
	//cout << "dir_name_selpaw:" << dir_name_selpaw << endl;
	file_w_selpaw.setName(path_to_be_written_selpaw);
	/////////////////////////////////////////////////////////////
	dir_selpaw.setFilter( QDir::Files );
        dir_selpaw.setSorting( QDir::Name );
	//files = dir.entryList("*.if");
	files_selpaw = dir_selpaw.entryList("interfaces_system.txt");
	/////////////////////////////////////////////////////////////
	it_d_selpaw = files_selpaw.begin();
	if (file_w_selpaw.exists()) {
		file_w_selpaw.remove();
	}
	
	if ( file_w_selpaw.open( IO_WriteOnly | IO_Append ) ) {
		while(it_d_selpaw != files_selpaw.end()){
			name_selpaw = *it_d_selpaw;
			file_interface_name_selpaw = dir_name_selpaw + forward_slash + name_selpaw;
			//cout << "file_interface_name_selpaw:" << file_interface_name_selpaw << endl;
			QFile file_selpaw( file_interface_name_selpaw );
			if ( file_selpaw.open( IO_ReadOnly ) ) {
				//cout << "file_selpaw_opened" << endl;
			    QTextStream stream_selpaw( &file_selpaw );
				layer_name = "system";
				////////////////////////////////////////////
				QRegExp rx_interface("^[a-zA-Z]");
				QRegExp rx_if_file_name("^:");
				QRegExp rx_colon(":");
				QRegExp rx_if(".if");
				QRegExp rx_gen_summary("^\\[summary\\]");
				QRegExp rx_template("^template");
				////////////////////////////////////////////
				int i,j,k = -1;
				while ( !stream_selpaw.atEnd() ) {
					line_analized = stream_selpaw.readLine(); // line of text excluding '\n'
					//cout << "line_analized:" << line_analized << endl;
					i = line_analized.find( rx_interface, 0);
					j = line_analized.find( rx_if_file_name, 0);
					k = line_analized.find( rx_gen_summary, 0);
					if( line_analized.find( rx_template, 0) != -1){
						interface_summary_this ="";
						line_analized ="";
						continue;
					}
					if(j != -1){
						line_analized = line_analized.replace(":","");		
						line_analized = line_analized.replace(".if","");		
						filename_this = line_analized;
					}
					if(k != -1){
						line_analized.replace("[summary]","");
						interface_summary_this += line_analized;
					}
					if((i != -1)&&(j == -1)&&(k == -1)){
						lines_selpaw += layer_name + cumma + filename_this + cumma + line_analized + cumma + "[summary]" + interface_summary_this + cumma;
						interface_summary_this = "";
					}
				}
				QTextStream stream_w_selpaw( &file_w_selpaw );
				for ( it_selpaw = lines_selpaw.begin(); it_selpaw != lines_selpaw.end(); ++it_selpaw ){
					stream_w_selpaw << *it_selpaw << "\n";
				}
				file_selpaw.close();
				lines_selpaw.clear();
				++it_d_selpaw;
			}else{
				//do nothing
			}
		}
	}
	file_w_selpaw.close();
}//end-selpaw_system_summary

//should be called from selpaw_admin()
void ParseLinesSelpaw::selpaw_admin_types_which_policy_has()
{
	//change path as you wish.
	/////////////////////////////////////////////////////////////
	path_selpaw = "./";
	path_to_be_written_selpaw = "./selpaw_admin_types_which_policy_has.txt";
	/////////////////////////////////////////////////////////////
	forward_slash = "/";
	cumma = ",";
	dir_selpaw.setPath(path);
	dir_name_selpaw = dir_selpaw.absPath();
	//cout << "dir_name_selpaw:" << dir_name_selpaw << endl;
	file_w_selpaw.setName(path_to_be_written_selpaw);
	/////////////////////////////////////////////////////////////
	dir_selpaw.setFilter( QDir::Files );
        dir_selpaw.setSorting( QDir::Name );
	//files = dir.entryList("*.if");
	files_selpaw = dir_selpaw.entryList("interfaces_admin.txt");
	/////////////////////////////////////////////////////////////
	it_d_selpaw = files_selpaw.begin();
	if (file_w_selpaw.exists()) {
		file_w_selpaw.remove();
	}
	
	if ( file_w_selpaw.open( IO_WriteOnly | IO_Append ) ) {
		while(it_d_selpaw != files_selpaw.end()){
			name_selpaw = *it_d_selpaw;
			file_interface_name_selpaw = dir_name_selpaw + forward_slash + name_selpaw;
			//cout << "file_interface_name_selpaw:" << file_interface_name_selpaw << endl;
			QFile file_selpaw( file_interface_name_selpaw );
			if ( file_selpaw.open( IO_ReadOnly ) ) {
				//cout << "file_selpaw_opened" << endl;
			    QTextStream stream_selpaw( &file_selpaw );
				layer_name = "admin";
				////////////////////////////////////////////
				QRegExp rx_interface("^[a-zA-Z]");
				QRegExp rx_if_file_name("^:");
				QRegExp rx_colon(":");
				QRegExp rx_if(".if");
				QRegExp rx_gen_require("\\[gen_require\\]");
				QRegExp rx_types("[a-zA-Z0-9_]+_t");//having x..._t
				QRegExp rx_template("^template");
				////////////////////////////////////////////
				int i,j,k,l = -1;
				int temp_int = 0;
				int str_start,str_end,str_len = 0;
				while ( !stream_selpaw.atEnd() ) {
					line_analized = stream_selpaw.readLine(); // line of text excluding '\n'
					//cout << "line_analized:" << line_analized << endl;
					i = line_analized.find( rx_interface, 0);
					j = line_analized.find( rx_if_file_name, 0);
					k = line_analized.find( rx_types, 0);
					l = line_analized.find( rx_gen_require, 0);
					if(i != -1){
						interface_name_this = line_analized;//this adds to lines. also append can be used
						temp_int = 0;
					}
					if( line_analized.find( rx_template, 0) != -1){
						temp_int = 1;
					}
					if(j != -1){
						line_analized = line_analized.replace(":","");		
						line_analized = line_analized.replace(".if","");		
						filename_this = line_analized;//this adds to lines. also append can be used
					}
					if((i == -1)&&(j == -1)&&(l != -1)&&(temp_int == 0)){
						line_analized = line_analized.stripWhiteSpace();
						lines_selpaw += layer_name + cumma + filename_this + cumma + interface_name_this + cumma + line_analized + cumma;
					}
					if((i == -1)&&(j == -1)&&(k != -1)&&(l == -1)&&(temp_int == 0)){
						str_start = line_analized.find( QRegExp("[a-zA-Z0-9_]*_t"), 0);
						str_end = line_analized.findRev( QRegExp("_t[^a-z]"));
						str_len = str_end - str_start + 2;
						line_analized = line_analized.mid( str_start, str_len );
						line_analized = line_analized.stripWhiteSpace();
						lines_selpaw += layer_name + cumma + filename_this + cumma + interface_name_this + cumma + "[gen_require_pol]" + line_analized + cumma;
					}
				}
				QTextStream stream_w_selpaw( &file_w_selpaw );
				for ( it_selpaw = lines_selpaw.begin(); it_selpaw != lines_selpaw.end(); ++it_selpaw ){
					stream_w_selpaw << *it_selpaw << "\n";
				}
				file_selpaw.close();
				lines_selpaw.clear();
				++it_d_selpaw;
			}else{
				//do nothing
			}
		}
	}
	file_w_selpaw.close();
}//end-selpaw_admin_types_which_policy_has

ParseLinesSelpaw::~ParseLinesSelpaw(){}
